<!DOCTYPE html>
<html lang="en">
<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Bootstrap Login &amp; Register Templates</title>

    <!-- CSS -->
    <link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Roboto:400,100,300,500">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
    <link rel="stylesheet" href="./admin/assets/font-awesome/css/font-awesome.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="plugins/toastr/toastr.min.css">
    <link rel="stylesheet" href="./admin/assets/css/form-elements.css">
    <link rel="stylesheet" href="./admin/assets/css/style.css">

    <!-- Favicon and touch icons -->
    <link rel="shortcut icon" href="./admin/assets/ico/favicon.png">
    <link rel="apple-touch-icon-precomposed" sizes="144x144" href="./admin/assets/ico/apple-touch-icon-144-precomposed.png">
    <link rel="apple-touch-icon-precomposed" sizes="114x114" href="./admin/assets/ico/apple-touch-icon-114-precomposed.png">
    <link rel="apple-touch-icon-precomposed" sizes="72x72" href="./admin/assets/ico/apple-touch-icon-72-precomposed.png">
    <link rel="apple-touch-icon-precomposed" href="./admin/assets/ico/apple-touch-icon-57-precomposed.png">

</head>

<body>

    <!-- Top content -->
    <div class="top-content">

        <div class="inner-bg">
            <div class="container">

                <div class="row justify-content-center">
                    <div class="col-sm-5">
                        <div class="form-box">
                            <div class="form-top">
                                <div class="form-top-left">
                                    <h1>Login</h1>
                                    <p>Enter email and password to log on:</p>
                                </div>
                                <div class="form-top-right">
                                    <i class="fa fa-key"></i>
                                </div>
                            </div>
                            <div class="form-bottom">
                                <div role="form" action="" method="post" class="login-form">
                                    <div class="form-group">
                                        <label class="sr-only" for="form-email">Email</label>
                                        <input type="email" name="form-email" placeholder="Email address..."
                                            class="form-email form-control" id="form-email">
                                    </div>
                                    <div class="form-group">
                                        <label class="sr-only" for="form-password">Password</label>
                                        <input type="password" name="form-password" placeholder="Password..."
                                            class="form-password form-control" id="form-password">
                                    </div>
                                    <button type="submit" class="btn" id="signin-btn">Sign in!</button>
                                    <a href="./signup.html" class="text-left d-block"
                                        style="color: #000; line-height: 45px;">Register here !</a>
                                </div>
                            </div>
                        </div>
                        <a href="./index.html" class="text-dark mt-5" style="font-weight: 600;"> &#8592; Quay lại trang chủ</a>

                    </div>
                    

                </div>

            </div>
        </div>

    </div>

    <!-- Javascript -->
    <script src="./admin/assets/js/jquery-1.11.1.min.js"></script>
    <script src="./admin/assets/bootstrap/js/bootstrap.min.js"></script>
    <script src="./admin/assets/js/jquery.backstretch.min.js"></script>
    <!-- Toastr -->
    <script src="plugins/toastr/toastr.min.js"></script>
    <script src="./admin/assets/js/scripts.js"></script>

    <script>
        //Kiểm tra token nếu có token tức người dùng đã đăng nhập
        const token = getCookie("token");
        var gMessage = "";
        var gCurrentPage = localStorage.getItem("current_page");
        var gCurrentPageAdmin = localStorage.getItem("current_page_admin");
        if(gCurrentPageAdmin == null){
            gCurrentPageAdmin = "./admin/index.html";
        }
        if (token) {
            window.location.href = gCurrentPage;
        }


        //Sự kiện bấm nút login
        $("#signin-btn").on("click", function () {
            var vEmail = $("#form-email").val().trim();
            var vPassword = $("#form-password").val().trim();

            if (validateData(vEmail, vPassword)) {
                signinForm(vEmail, vPassword);
                $("#signin-btn").removeClass("toastrDefaultError");
            }
        })
        //Hàm signin form
        function signinForm(paramEmail, paramPassword) {

            //API theo đặc tả sẽ call theo data-form chứ không phải kiểu json nên cần khai báo formdata
            var formData = {
                email: paramEmail,
                password: paramPassword
            };

            $.ajax({
                url: "http://localhost:8080/api/auth/signin",
                type: "POST",
                data: JSON.stringify(formData),
                contentType: "application/json; charset=utf-8",
                success: function (responseObject) {
                    responseHandler(responseObject);

                },
                error: function (pAjaxContext) {
                    gMessage = "email hoặc mật khẩu không chính xác vui lòng nhập lại!"
                    toastr.error(gMessage);
                }
            });
        }

        //Xử lý object trả về khi login thành công
        function responseHandler(data) {
            //Lưu token vào cookie trong 1 ngày
            setCookie("token", data.accessToken, 1);
            if (data.roles[0] === "ROLE_USER") {
                window.location.href = gCurrentPage;
            }
            else if (data.roles[0] === "ROLE_ADMIN" || data.roles[0] === "ROLE_MANAGER") {
                window.location.href = gCurrentPageAdmin;
            }

        }


        //Validate dữ liệu từ form
        function validateData(email, password) {
            if (email === "") {
                gMessage = "email không phù hợp";
                $("#login").addClass("toastrDefaultError");
                toastr.error(gMessage)
                return false;
            }

            if (password === "") {
                gMessage = "password không phù hợp";
                $("#login").addClass("toastrDefaultError");
                toastr.error(gMessage)
                return false;
            }

            return true;
        }

        //Hàm get Cookie đã giới thiệu ở bài trước
        function getCookie(cname) {
            var name = cname + "=";
            var decodedCookie = decodeURIComponent(document.cookie);
            var ca = decodedCookie.split(';');
            for (var i = 0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) == ' ') {
                    c = c.substring(1);
                }
                if (c.indexOf(name) == 0) {
                    return c.substring(name.length, c.length);
                }
            }
            return "";
        }

        //Hàm setCookie đã giới thiệu ở bài trước
        function setCookie(cname, cvalue, exdays) {
            var d = new Date();
            d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
            var expires = "expires=" + d.toUTCString();
            document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
        }

    </script>
</body>

</html>